#ifndef SAMPLE_HPP
#define SAMPLE_HPP

#include "TIME.hpp"
#include "THREADS.hpp"
#include "DATA.hpp"
#include "SERIAL.hpp"
#include "LED.hpp"
#include "LCD_COMMAND.hpp"
#include "sample_hardware.hpp"

//Signal Definitions
#define SamplingTime 1
#define SerialCommsTime 1
#define NotSerialCommsTime 0
#define NotSamplingTime 0
#define Print_Time_to_LCD 1
#define Dont_Print_Time_to_LCD 0
#define EDGE_RISEN 1
#define EDGE_FALLEN 0
#define SD_Data_Ready 1
#define No_SD_Data_Ready 0
#define Do_Read_Data 1
#define Dont_Read_Data 0
#define Do_Delete_Data 1
#define Dont_Delete_Data 0

extern void Sampling_ISR();
extern void Sample_Event();

//LED object constructors
static LED Red_led(PE_15);
static LED Yellow_led(PB_10);
static LED Green_led(PB_11);



#endif